//	OverPrint_Search.js
//	http://www.pictrix.jp/	Umezawa
//	05.5.12	10:59 AM

var Clr = 0;
var Lock = 0;
var Count = 0;

if ( documents.length > 0 ){

	doc = activeDocument;

	ans = confirm( "Do you remove overprint setting ?" );
	if ( ans == true ) Clr = 1;

	if ( doc.selection.length ){
		sel = doc.selection;
		for ( i = 0; i < sel.length; i++ ) sel[ i ].selected = false;
		for ( i = 0; i < sel.length; i++ ) engine( sel[ i ] );
	}
	else{
		ans = confirm( "Do you access the lock and the hidden item ?" );
		if ( ans == true ) Lock = 1;
		engine( doc );
	}

	alert( "Object : " + Count );
}


function engine( xObj )
{
	var i;
	var obj, tname;

	tname = xObj.typename;

	if( tname == "GroupItem" || tname == "Document" ){

		obj = xObj.groupItems;
		for ( i = 0; i < obj.length; i++ ) engine( obj[ i ] );

		selOPs( xObj.pathItems , 0 );
		selOPs( xObj.textFrames , 1);
		for ( i = 0; i < xObj.compoundPathItems.length; i++ ){
			selOPs( xObj.compoundPathItems[ i ].pathItems , 0 );
		}
	}
	else{
		if ( tname == "PathItem" ) selOP1( xObj , 0 );
		else
			if ( tname == "TextFrame" ) selOP1( xObj , 1 );
			else
				if ( tname == "CompoundPathItem" ) selOPs( xObj.pathItems , 0 );
	}
}


function selOPs( itm , sw )
{
	for ( var i = 0; i < itm.length; i++ ) selOP1( itm[ i ] , sw );
}


function selOP1( itm , sw )
{
//$.level = 1;
//$.bp();

	if ( itm.editable == false && Lock == 0 ) return;

	switch ( sw ){
		case 0 :
			if ( itm.fillOverprint == true || itm.strokeOverprint == true ){
				Count++;
				if ( itm.editable == false ) editOn( itm );
				itm.selected = true;
				if ( Clr ){
					itm.fillOverprint = false;
					itm.strokeOverprint = false;
				}
			}
			break;
		case 1 :
			var e1 = itm.layer.locked;
			var e2 = itm.layer.visible;
			var e3 = itm.locked;
			var e4 = itm.hidden;
			var st = itm.story;
			var tr = st.textRanges;
			var op = 0;
			var cat, i;

			if ( itm.editable == false ) editOn( itm );	
			for ( i = 0; i < tr.length; i++ ){
				cat = tr[ i ].characterAttributes;
				if ( cat.overprintFill == true || cat.overprintStroke == true ){
					if ( Clr ){
						itm.textRange.overprintFill = false;
						itm.textRange.overprintStroke = false;
					}
					op = 1;
					break;
				}
			}
			if ( op ){
				Count++;
				itm.selected = true;
			}
			else{
				itm.locked = e3;
				itm.hidden = e4;
				itm.layer.locked = e1;
				itm.layer.visible = e2;
			}
			break;
	}
}


function editOn( itm )
{
	itm.layer.locked = false;
	itm.layer.visible = true;
	itm.locked = false;
	itm.hidden = false;
}


